﻿#from __future__ import print_function
from ctypes import *
import os
dll = CDLL("HSDAQ.dll")

IP="10.0.8.221"
chcnt=2
Gain=0
triggermode=0
samplerate=20000
targetCnt=20000
DatatransMethod=0
AutoRun=0
BufferStatus=0
BufferCnt=0
fdatabuffer = [1.0]
print('IntIP,'+IP)
print(targetCnt)
#與module連線
#Connect to module
dll.HS_Device_Create.restype=c_void_p
Hhs = dll.HS_Device_Create(c_char_p(IP.encode('utf-8')))


#設定採樣參數，設定HS_SetAIScanParam寫入的參數資料型態和回傳的資料型態(給Python識別用)
#Set sampling parameters, set the parameter data type written by HS_SetAIScanParam and the returned data type (for Python recognition)
dll.HS_SetAIScanParam.argtypes=c_void_p,c_short,c_short,c_short,c_long,c_ulong,c_short,c_short
dll.HS_SetAIScanParam.restype=c_bool
ret=dll.HS_SetAIScanParam(Hhs,chcnt,Gain,triggermode,samplerate,targetCnt,DatatransMethod,AutoRun)
if(not ret):
    print('error code: '+hex(dll.HS_GetLastError()))
chcnt=c_short()
Gain=c_short()
triggermode=c_short()
samplerate=c_long()
targetCnt=c_ulong()
DatatransMethod=c_short()
AutoRun=c_short()

#HS_GetAIScanParam(HANDLE obj, short *pacerChCnt, short *pacerGain, short *triggerMode, long *sampleRate, unsigned long *targetCnt, short *DataTransMethod, short *AutoRun);
#取得module目前參數設定，設定HS_GetAIScanParam的取得參數資料型態(給Python識別用)
#Get the current parameter settings of the module, set the HS_GetAIScanParam to get the parameter data type (for Python recognition)
dll.HS_GetAIScanParam.argtypes=c_void_p,
dll.HS_GetAIScanParam.restype=c_bool
dll.HS_GetAIScanParam(Hhs,byref(chcnt),byref(Gain),byref(triggermode),byref(samplerate),byref(targetCnt),byref(DatatransMethod),byref(AutoRun))
print('CH:'+str(chcnt.value))
print('Gain:'+str(Gain.value))
print('Mode:'+str(triggermode.value))
print('Samplerate:'+str(samplerate.value))
print('TargetCnt:'+str(targetCnt.value))


#開始採樣
#Start sampling
dll.HS_StartAIScan.argtypes=c_void_p,
dll.HS_StartAIScan(Hhs)
dll.HS_GetAIBufferStatus.argtypes=c_void_p,
dll.HS_StopAIScan.argtypes=c_void_p,
dll.HS_GetAIBuffer.argtypes=c_void_p,
run=True
while run :

    #HS_GetAIBufferStatus(HANDLE obj,WORD *wBufferStatus, DWORD *dwDataCountOnBuffer);
    BufferCnt=c_ulong()
    BufferStatus=c_short()
    #確認Buffer狀態、已傳回筆數
	#Confirm the Buffer status and the number of returned transactions
    dll.HS_GetAIBufferStatus(Hhs,byref(BufferStatus),byref(BufferCnt))
    print("\rCnt:"+str(BufferCnt.value),end='\r')
    if ((BufferStatus.value & 0x02) == 0x02):
        print('error code: '+hex(dll.HS_GetLastError()))
        dll.HS_StopAIScan(Hhs)
    else:
        if BufferCnt.value >= targetCnt.value :
            fdatabuffer = (c_float * BufferCnt.value)()
            dll.HS_GetAIBuffer(Hhs,fdatabuffer,BufferCnt.value)
            run=False


#結束採樣
#Stop sampling
dll.HS_StopAIScan(Hhs)
print('')
#印出前1000筆資料，每個ch的資料為1000/2=500筆
#Print out the first 1000 data, each ch data is 1000/2=500

for i in range(0,1000,2):
    print(str(fdatabuffer[i])+','+str(fdatabuffer[i+1]))

#與module結束連線
#End the connection with the module
dll.HS_Device_Release.argtypes=c_void_p,
dll.HS_Device_Release(Hhs)
print('End')



